# GraphPolaris Frontend

## Preparing to Run Locally

Due to the way auth works (using a sameSite cookie), the procedure for running locally is a little different than usual. These steps will only have to be done, after that everything should 'just' work.

### MacOS / Linux

1. `sudo vim /etc/hosts` open the hosts file with your prefered text editor as root
2. Add a new row containing `127.0.0.1 local.graphpolaris.com`, this will route traffic from `local.graphpolaris.com` to `127.0.0.1`
3. `brew install mkcert` install mkcert utility
4. `mkcert -install` generate local CA (certificate authority)
5. Move into the /certs folder at the project root using `cd`
6. `mkcert --key-file local-key.pem --cert-file local-cert.pem local.graphpolaris.com` create certificates for local SSL

### Windows

1. Open the `hosts` file under `C:\Windows\System32\drivers\etc` using a text editor, as administrator
2. Add a new row containing `127.0.0.1 local.graphpolaris.com`, this will route traffic from `local.graphpolaris.com` to `127.0.0.1`
3. Install mkcert using any of the ways described [here](https://github.com/FiloSottile/mkcert#windows)
4. Open an elevated Powershell or CMD session
5. Move into the /certs folder at the project root using `cd`
6. `mkcert --key-file local-key.pem --cert-file local-cert.pem local.graphpolaris.com` create certificates for local SSL

> No idea if the Windows steps work

## Running Locally

To run the application using SSL (with these keys) simply run `nx run web-graphpolaris:dev`, or `yarn nx run web-graphpolaris:dev` if `nx` is not installed globally. This should open a window to `https://local.graphpolaris.com:4200/` automatically.
