// All user related API calls

import { AuthorizationHandler } from '@graphpolaris/shared/data-access/authorization';

export type User = {
  Name: string;
  Email: string;
  SignInProvider: number;
};

export function GetUserInfo(): Promise<User> {
  return new Promise<User>((resolve, reject) => {
    fetch('https://api.graphpolaris.com/user/', {
      method: 'GET',
      credentials: 'same-origin',
      headers: new Headers({
        Authorization:
          'Bearer ' + AuthorizationHandler.instance().AccessToken(),
      }),
    })
      .then((response: Response) => {
        if (!response.ok) {
          reject(response.statusText);
        }

        return response.json();
      })
      .then((json: any) => {
        resolve({
          Name: json.name,
          Email: json.email,
          SignInProvider: json.sign_in_provider,
        });
      });
  });
}
